# UIM

UI Manager with sequential building and runtime hot reloading.

## Tools

1. [VS Code](https://code.visualstudio.com) - IDE/Code editor that will help us with better use of types, intellisense, function/method documents and more, though it requires a Lua LSP for syntaxing and type support.

2. [Rojo](https://rojo.space/docs/v7/) - In order to work with the game project through VS-Code sync to Roblox Studio.

3. [Rojo UI](https://marketplace.visualstudio.com/items?itemName=muoshuu.rojo-ui) - Integrates a UI into VS Code that allows one to browse the game workspace and any instance's properties.

4. [Wally](https://wally.run/install) - Package manager specifically for Roblox use cases.

5. Selene - For code quality and standard, it is a linter, if you're familiar with that. | When installing Rust, please select option 1.
    [Step 1](https://kampfkarren.github.io/selene/cli/installation.html)
    [Step 2](https://kampfkarren.github.io/selene/roblox.html)
   Or, alternatively, you can use the [VS Code extension](https://marketplace.visualstudio.com/items?itemName=Kampfkarren.selene-vscode).

6. LSP - [[Roblox Lua LSP](https://marketplace.visualstudio.com/items?itemName=Nightrains.robloxlsp)] or [[Luau LSP](https://marketplace.visualstudio.com/items?itemName=JohnnyMorganz.luau-lsp)]
   What're the differences? Luau LSP provides in-editor type checking. Roblox Lua LSP does not. Lua LSP is by far the most superior way to go.

7. [Git](https://git-scm.com) - Versiona management tool for your command line/terminal. This allows you to access and utilize github in a more streamlined manner to both pull and push updates.
